// Conti_InterpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Conti_Interp.h"
#include "Conti_InterpDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define AXIS_STATUS_TIMER_ID			1
#define INTERPOLATION_READY_TIMER_ID	2

CONTI_INTERP_SEGMENT ContiInterpSeg[MAX_INTERP_SEGMENT] = {
	{ 45000,     0,       0,      0},   // Continue-Interpolation Segment 1
	{ 15000,  15000,      0,  15000},   // Continue-Interpolation Segment 2
	{     0,  15000,      0,      0},   // Continue-Interpolation Segment 3
	{-15000,  15000, -15000,      0},   // Continue-Interpolation Segment 4
	{-45000,      0,      0,      0},   // Continue-Interpolation Segment 5
	{-15000, -15000,      0, -15000},   // Continue-Interpolation Segment 6
	{     0, -15000,      0,      0},   // Continue-Interpolation Segment 7
	{ 15000, -15000,  15000,      0} }; // Continue-Interpolation Segment 8

// CConti_InterpDlg dialog

CConti_InterpDlg::CConti_InterpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConti_InterpDlg::IDD, pParent)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, m_ModuleNum(0)
	, m_ErrorOccure(0x00)
	, m_SegIndex(0)
	, m_SegRun(-1)
	, m_bDone(MOTION_NOT_DONE)
	, m_nTimer(-1)
	, m_nTimer2(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CConti_InterpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_START, m_btMove);
	DDX_Control(pDX, IDC_BT_RESET_CNTER, m_btClear);
}

BEGIN_MESSAGE_MAP(CConti_InterpDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BT_START, &CConti_InterpDlg::OnRectangleMove)
	ON_BN_CLICKED(IDC_BT_RESET_CNTER, &CConti_InterpDlg::OnResetCounter)
END_MESSAGE_MAP()


// CConti_InterpDlg message handlers

BOOL CConti_InterpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st I8094/F
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_X, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_Y, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_X, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_Y, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_Y, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_cmdcounter(m_CurSlotNo, AXIS_X, 0)) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_cmdcounter(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}
				if( (nErrCode = i8094_set_cmdcounter(m_CurSlotNo, AXIS_Y, 0)) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_cmdcounter(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				m_btMove.EnableWindow( TRUE );

Initial_Error:
				if( nErrCode == SUCCESS_NO_ERROR )
				{
					m_nTimer = SetTimer( AXIS_STATUS_TIMER_ID, 100, NULL );
				}

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CConti_InterpDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_CONTI_INTERP_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_CONTI_INTERP_DIALOG));
	}
}
#endif


void CConti_InterpDlg::OnDestroy()
{
	short nErrCode;

	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( m_nTimer != -1 )
	{
		KillTimer( m_nTimer );
		m_nTimer = -1;
	}

	if( m_nTimer2 != -1 )
	{
		KillTimer( m_nTimer2 );
		m_nTimer2 = -1;
	}


	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		nErrCode = i8094_conti_interp_end( m_CurSlotNo );
		nErrCode = i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}			
}

void CConti_InterpDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	short nErrCode; 
	long nCmdCounterX, nCmdCounterY;
	DWORD dwCurSpeed;
	CString strTmp;
	BYTE bReady;
	WORD wStopStatus;
	int SegRunning = -1;

	if ( nIDEvent == INTERPOLATION_READY_TIMER_ID )
	{
		if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
		{	
			if( (nErrCode = i8094_conti_interp_next_ready( m_CurSlotNo, &bReady )) != SUCCESS_NO_ERROR )
			{
				i8094_conti_interp_end( m_CurSlotNo);
				TRACE( TEXT(" i8094_conti_interp_next_ready() failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
			else
			{
				if( bReady == CONTINUE_INTERPOLATION_NEXT_READY )
				{
					if( (m_SegIndex % 2) == 0 )  // Segment 1, 3, 5, 7 - Linear Interpolation
					{
						if( (nErrCode = i8094_conti_line2_move( m_CurSlotNo, ContiInterpSeg[m_SegIndex].MainAxisFinishPoint, ContiInterpSeg[m_SegIndex].SlaveAxisFinishPoint, INTERP_NEXT_CONTINUOUS_MOTION )) != SUCCESS_NO_ERROR )
						{
							i8094_conti_interp_end( m_CurSlotNo );
							TRACE( TEXT(" i8094_conti_line2_move(AXIS_X) failed, error code = %d\n"), nErrCode );
							m_ErrorOccure = 0x01;
						}
						else
						{
							m_SegIndex ++;
						}
					}
					else // Segment 2, 4, 6, 8 - Arc Interpolation
					{
						if( (nErrCode = i8094_conti_arc2_move( m_CurSlotNo, INTERP_ARC_DIRECTION_COUNTER_CLOCKWISE, ContiInterpSeg[m_SegIndex].MainAxisCenterPoint, ContiInterpSeg[m_SegIndex].SlaveAxisCenterPoint, ContiInterpSeg[m_SegIndex].MainAxisFinishPoint, ContiInterpSeg[m_SegIndex].SlaveAxisFinishPoint, INTERP_NEXT_CONTINUOUS_MOTION )) != SUCCESS_NO_ERROR )
						{
							i8094_conti_interp_end( m_CurSlotNo );
							TRACE( TEXT(" i8094_conti_arc2_move(AXIS_X) failed, error code = %d\n"), nErrCode );
							m_ErrorOccure = 0x01;
						}
						else
						{
							m_SegIndex ++;
						}
					} // if( (m_SegIndex % 2) == 0 ) 		

					if( m_SegIndex >= MAX_INTERP_SEGMENT ) // End Continue-Interpolation
					{
						KillTimer( m_nTimer2 );
						m_nTimer2 = -1;
					}

				} // if( bReady == CONTINUE_INTERPOLATION_NEXT_READY )
			}
		}
	}
	else if( nIDEvent == AXIS_STATUS_TIMER_ID )
	{
		if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
		{	
			if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &nCmdCounterX )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
		
			if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_X, &dwCurSpeed )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_speed(AXIS_X) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}

			strTmp.Format( TEXT("%d"), nCmdCounterX );
			SetDlgItemText( IDC_STATIC_LP, strTmp );

			strTmp.Format( TEXT("%d"), dwCurSpeed );
			SetDlgItemText( IDC_STATIC_CV, strTmp );


			if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_Y, &nCmdCounterY )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
		
			if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_Y, &dwCurSpeed )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_speed(AXIS_Y) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}

			strTmp.Format( TEXT("%d"), nCmdCounterY );
			SetDlgItemText( IDC_STATIC_LP2, strTmp );

			strTmp.Format( TEXT("%d"), dwCurSpeed );
			SetDlgItemText( IDC_STATIC_CV2, strTmp );


			if( (0 < nCmdCounterX) && (nCmdCounterX < 45000) && (nCmdCounterY == 0 ) )
			{
				SegRunning = 0;
			}
			else if( (45000 < nCmdCounterX) && (nCmdCounterX < 60000) && (0 < nCmdCounterY) && (nCmdCounterY < 15000) )
			{
				SegRunning = 1;
			}
			else if( (nCmdCounterX == 60000) && (15000 < nCmdCounterY) && (nCmdCounterY < 30000) )
			{
				SegRunning = 2;
			}
			else if( (45000 < nCmdCounterX) && (nCmdCounterX < 60000)  && (30000 < nCmdCounterY) && (nCmdCounterY < 45000) )
			{
				SegRunning = 3;
			}
			else if( (0 < nCmdCounterX) && (nCmdCounterX < 45000) && (nCmdCounterY == 45000 ) )
			{
				SegRunning = 4;
			}
			else if( (-15000 < nCmdCounterX) && (nCmdCounterX < 0) && (30000 < nCmdCounterY) && (nCmdCounterY < 45000) )
			{
				SegRunning = 5;
			}
			else if( (nCmdCounterX == -15000) && (15000 < nCmdCounterY) && (nCmdCounterY < 30000) )
			{
				SegRunning = 6;
			}
			else if( (-15000 < nCmdCounterX) && (nCmdCounterX < 0)  && (0 < nCmdCounterY) && (nCmdCounterY < 15000) )
			{
				SegRunning = 7;
			}


			if( (m_SegRun != SegRunning) && (m_bDone != MOTION_DONE) ) // change is needed
			{
				if( (m_SegRun == 7) && (SegRunning == -1) )
					m_SegRun = 8;
				else
					m_SegRun = SegRunning;
			}


			if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &m_bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
			else
			{
				if( (m_bDone == MOTION_DONE) && (m_SegIndex > 0) )
				{
					m_SegIndex = 0;
					m_btMove.EnableWindow( TRUE );
					m_btClear.EnableWindow( TRUE );

					if( (nErrCode = i8094_conti_interp_end( m_CurSlotNo )) != SUCCESS_NO_ERROR )
					{
						TRACE( TEXT(" i8094_conti_interp_end() failed, error code = %d\n"), nErrCode );
					}

				}	
			}
		}	
	}


	CDialog::OnTimer(nIDEvent);
}

void CConti_InterpDlg::OnRectangleMove()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;	

	// reset m_SegIndex
	if( (nErrCode = i8094_conti_interp_begin( m_CurSlotNo, AXIS_X, AXIS_Y, 0x00, 5000 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_conti_interp_begin(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_conti_line2_move( m_CurSlotNo, ContiInterpSeg[m_SegIndex].MainAxisFinishPoint, ContiInterpSeg[m_SegIndex].SlaveAxisFinishPoint, INTERP_CONTINUE_START )) != SUCCESS_NO_ERROR )
	{
		i8094_conti_interp_end( m_CurSlotNo);
		strErrMsg.Format( TEXT(" i8094_conti_line2_move(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}
	else
	{
		m_SegIndex ++;
		m_nTimer2 = SetTimer( INTERPOLATION_READY_TIMER_ID, 5, NULL );

		m_btMove.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );
	}	
}

void CConti_InterpDlg::OnResetCounter()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;
	
	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	
}
