// Helix_MoveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Helix_Move.h"
#include "Helix_MoveDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define Pi 3.1415926

#define TOTAL_CIRCULAR_MOTION			3

#define AXIS_STATUS_TIMER_ID			1
#define INTERPOLATION_READY_TIMER_ID	2

// CHelix_MoveDlg dialog

CHelix_MoveDlg::CHelix_MoveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHelix_MoveDlg::IDD, pParent)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, m_ErrorOccure(0)
	, m_Circles(0)
	, nTimer(-1)
	, nTimer2(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHelix_MoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_MOVE, m_btMove);
	DDX_Control(pDX, IDC_BT_RESET_CNTER, m_btClear);
}

BEGIN_MESSAGE_MAP(CHelix_MoveDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BT_MOVE, &CHelix_MoveDlg::OnHelixMove)
	ON_BN_CLICKED(IDC_BT_RESET_CNTER, &CHelix_MoveDlg::OnResetCounter)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CHelix_MoveDlg message handlers

BOOL CHelix_MoveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st PISO-PS400
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_X, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_Y, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, AXIS_Z, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_Z) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_X, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_Y, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, AXIS_Z, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_Z) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_Y, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_Y) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_Z, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_Z) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				nTimer = SetTimer( AXIS_STATUS_TIMER_ID, 200, NULL );
Initial_Error:
				if( nErrCode == SUCCESS_NO_ERROR )
				{
					m_btMove.EnableWindow( TRUE );
					m_btClear.EnableWindow( TRUE );
				}

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}			
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CHelix_MoveDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_HELIX_MOVE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_HELIX_MOVE_DIALOG));
	}
}
#endif


void CHelix_MoveDlg::OnDestroy()
{
	short nErrCode; 
	CString strTmp;

	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
	{
		KillTimer( nTimer );
		nTimer = -1;
	}

	if( nTimer2 != -1 )
	{
		KillTimer( nTimer2 );
		nTimer2 = -1;
	}


	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		nErrCode = i8094_conti_interp_end( m_CurSlotNo );
		nErrCode = i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}
}

void CHelix_MoveDlg::OnHelixMove()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;
	WORD wAxes = (AXIS_X | AXIS_Y | AXIS_Z);
	double fRadius, fCircularPath, fTotalTime, fLinearSpeed;
	DWORD dwDriveSpeed;
	long lFixedPulse;

	// calculate the speed of linear-move
	fRadius = sqrt(2) * 1000.0 ; 
	fCircularPath = 2.0 * Pi * fRadius * 3.0;
	fTotalTime = (fCircularPath / 5000.0);
	fLinearSpeed = (1000.0 * 3.0) / fTotalTime;
	dwDriveSpeed = (DWORD) floor( fLinearSpeed );
	lFixedPulse = 1000 * 3;

	// Hold all related axes.
	if( (nErrCode = i8094_drv_hold( m_CurSlotNo, wAxes )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_drv_hold() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	// start linear constant speed move
	if( (nErrCode = i8094_const_move( m_CurSlotNo, AXIS_Z, dwDriveSpeed, lFixedPulse )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_const_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		// release the hold-state
		i8094_drv_start( m_CurSlotNo, wAxes );
		return;
	}

	// configure the continous interpoltaion
	if( (nErrCode = i8094_conti_interp_begin( m_CurSlotNo, AXIS_X, AXIS_Y, 0x00, 5000 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_conti_interp_begin() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		// release the hold-state
		i8094_drv_start( m_CurSlotNo, wAxes );
		return;
	}

	if( (nErrCode = i8094_conti_arc2_move( m_CurSlotNo, INTERP_ARC_DIRECTION_CLOCKWISE, 1000, 1000, 0, 0, INTERP_CONTINUE_START )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_conti_arc2_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		// release the hold-state
		i8094_drv_start( m_CurSlotNo, wAxes );
		return;
	}

	// start the hold axes
	if( (nErrCode = i8094_drv_start( m_CurSlotNo, wAxes )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_drv_start() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	m_btMove.EnableWindow( FALSE );
	m_btClear.EnableWindow( FALSE );
	m_Circles ++;
	nTimer2 = SetTimer( INTERPOLATION_READY_TIMER_ID, 5, NULL );
}

void CHelix_MoveDlg::OnResetCounter()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;
	
	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, AXIS_Z, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter(AXIS_Z) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, AXIS_X, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter(AXIS_X) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, AXIS_Y, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}		

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, AXIS_Z, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter(AXIS_Z) failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}
}

void CHelix_MoveDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	short nErrCode; 
	long nCmdCounter;
	DWORD dwCurSpeed;
	CString strTmp;
	BYTE bDone, bReady;
	WORD wStopStatus;

	if ( nIDEvent == INTERPOLATION_READY_TIMER_ID )
	{
		if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
		{	
			if( (nErrCode = i8094_conti_interp_next_ready( m_CurSlotNo, &bReady )) != SUCCESS_NO_ERROR )
			{
				i8094_conti_interp_end( m_CurSlotNo );
				TRACE( TEXT(" i8094_conti_interp_next_ready() failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
			else
			{
				if( bReady == CONTINUE_INTERPOLATION_NEXT_READY )
				{
					if( m_Circles < TOTAL_CIRCULAR_MOTION )  // Segment 1, 3, 5, 7 - Linear Interpolation
					{
						if( (nErrCode = i8094_conti_arc2_move( m_CurSlotNo, INTERP_ARC_DIRECTION_CLOCKWISE, 1000, 1000, 0, 0, INTERP_NEXT_CONTINUOUS_MOTION )) != SUCCESS_NO_ERROR )
						{
							i8094_conti_interp_end( m_CurSlotNo );
							TRACE( TEXT(" i8094_conti_arc2_move(AXIS_X) failed, error code = %d\n"), nErrCode );
							m_ErrorOccure = 0x01;
						}
						else
						{
							m_Circles ++;
						}
					}
					else // m_Circles >= TOTAL_CIRCULAR_MOTION
					{
						KillTimer( nTimer2 );
						nTimer2 = -1;
						m_Circles = 0;
					}

				} // if( bReady == CONTINUE_INTERPOLATION_NEXT_READY )
			}
		}
	}
	else if( nIDEvent == AXIS_STATUS_TIMER_ID )
	{
		if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
		{	
			if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_X, &nCmdCounter )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_cmdcounter(AXIS_X) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
		
			if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_X, &dwCurSpeed )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_speed(AXIS_X) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}

			strTmp.Format( TEXT("%d"), nCmdCounter );
			SetDlgItemText( IDC_STATIC_LP, strTmp );

			strTmp.Format( TEXT("%d"), dwCurSpeed );
			SetDlgItemText( IDC_STATIC_CV, strTmp );


			if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_Y, &nCmdCounter )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_cmdcounter(AXIS_Y) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
		
			if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_Y, &dwCurSpeed )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_speed(AXIS_Y) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}

			strTmp.Format( TEXT("%d"), nCmdCounter );
			SetDlgItemText( IDC_STATIC_LP2, strTmp );

			strTmp.Format( TEXT("%d"), dwCurSpeed );
			SetDlgItemText( IDC_STATIC_CV2, strTmp );

			if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, AXIS_Z, &nCmdCounter )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_cmdcounter(AXIS_Z) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
		
			if( (nErrCode = i8094_get_speed( m_CurSlotNo, AXIS_Z, &dwCurSpeed )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_get_speed(AXIS_Z) failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}

			strTmp.Format( TEXT("%d"), nCmdCounter );
			SetDlgItemText( IDC_STATIC_LP3, strTmp );

			strTmp.Format( TEXT("%d"), dwCurSpeed );
			SetDlgItemText( IDC_STATIC_CV3, strTmp );

			if( (nErrCode = i8094_motion_done( m_CurSlotNo, AXIS_X, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
			{
				TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
				m_ErrorOccure = 0x01;
			}
			else
			{
				if( bDone == MOTION_DONE )
				{
					m_btMove.EnableWindow( TRUE );
					m_btClear.EnableWindow( TRUE );

					if( (nErrCode = i8094_conti_interp_end( m_CurSlotNo )) != SUCCESS_NO_ERROR )
					{
						TRACE( TEXT(" i8094_conti_interp_end() failed, error code = %d\n"), nErrCode );
					}

				}	
			}
		}	
	}	
	

	CDialog::OnTimer(nIDEvent);
}
