// Manual_Pulse_GeneratorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Manual_Pulse_Generator.h"
#include "Manual_Pulse_GeneratorDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define wTarget_Axis		AXIS_X

// CManual_Pulse_GeneratorDlg dialog

CManual_Pulse_GeneratorDlg::CManual_Pulse_GeneratorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CManual_Pulse_GeneratorDlg::IDD, pParent)
	, m_dwFixedPulse(5)
	, m_dwSpeed(60000)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
	, m_bEnable( false )
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CManual_Pulse_GeneratorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_ENABLE, m_btEnable);
	DDX_Text(pDX, IDC_EDIT_PULSE_RATIO, m_dwFixedPulse);
	DDX_Text(pDX, IDC_EDIT_SPEED, m_dwSpeed);
}

BEGIN_MESSAGE_MAP(CManual_Pulse_GeneratorDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BT_ENABLE, &CManual_Pulse_GeneratorDlg::OnMPGEnable)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CManual_Pulse_GeneratorDlg message handlers

BOOL CManual_Pulse_GeneratorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here

	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st PISO-PS400
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, wTarget_Axis, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, wTarget_Axis, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, AXIS_X, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit(AXIS_X) falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				nTimer = SetTimer( 1, 200, NULL );
Initial_Error:

				if( nErrCode == SUCCESS_NO_ERROR )
					m_btEnable.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CManual_Pulse_GeneratorDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MANUAL_PULSE_GENERATOR_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MANUAL_PULSE_GENERATOR_DIALOG));
	}
}
#endif


void CManual_Pulse_GeneratorDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_set_mpg( m_CurSlotNo, wTarget_Axis, EXP_DISABLE_FEATURE, 0, 0, 0 );
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}		
}

void CManual_Pulse_GeneratorDlg::OnMPGEnable()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;


	if( m_bEnable == FALSE )
	{
		UpdateData( TRUE );
		if( (nErrCode = i8094_set_mpg( m_CurSlotNo, wTarget_Axis, EXP_AB_PHASE_MPG, m_dwFixedPulse, m_dwSpeed, 5000 )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_set_mpg() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
		else
		{
			m_bEnable = TRUE;
			m_btEnable.SetWindowText( TEXT("Disable MPG" ));
		}
	}
	else
	{
		if( (nErrCode = i8094_set_mpg( m_CurSlotNo, wTarget_Axis, EXP_DISABLE_FEATURE, 0, 0, 0 )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_set_mpg() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
		else
		{
			m_bEnable = FALSE;
			m_btEnable.SetWindowText( TEXT("Enable MPG" ));
		}
	}
}

void CManual_Pulse_GeneratorDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter;
	DWORD dwCurSpeed;
	short nError;
	CString strTmp;

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nError = i8094_get_cmdcounter( m_CurSlotNo, wTarget_Axis, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter() failed, error code = %d\n"), nError );
		}
		
		if( (nError = i8094_get_speed( m_CurSlotNo, wTarget_Axis, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed() failed, error code = %d\n"), nError );
		}

		strTmp.Format( TEXT("%d"), nCmdCounter );
		SetDlgItemText( IDC_STATIC_LP, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeed );
		SetDlgItemText( IDC_STATIC_CV, strTmp );

	}	

	CDialog::OnTimer(nIDEvent);
}
