// Software_LimitDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Software_Limit.h"
#include "Software_LimitDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSoftware_LimitDlg dialog

#define wTarget_Axis		AXIS_X

CSoftware_LimitDlg::CSoftware_LimitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSoftware_LimitDlg::IDD, pParent)
	, m_strCV(_T(""))
	, m_strCA(_T(""))
	, m_strEP(_T(""))
	, m_strLP(_T(""))
	, m_dwP(60000)
	, m_bEnSWLimit(FALSE)
	, m_lSLMTP(50000)
	, m_lSLMTM(-50000)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSoftware_LimitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_COUNTER_CLEAR, m_btClear);
	DDX_Control(pDX, IDC_BT_MOVE, m_btMove);
	DDX_Control(pDX, IDC_BT_MOVE2, m_btMove2);
	DDX_Control(pDX, IDC_STATIC_SLMTM_OFF, m_iconSLMTM_OFF);
	DDX_Control(pDX, IDC_STATIC_SLMTM_ON, m_iconSLMTM_ON);
	DDX_Control(pDX, IDC_STATIC_SLMTP_OFF, m_iconSLMTP_OFF);
	DDX_Control(pDX, IDC_STATIC_SLMTP_ON, m_iconSLMTP_ON);
	DDX_Text(pDX, IDC_STATIC_CA, m_strCA);
	DDX_Text(pDX, IDC_STATIC_CV, m_strCV);
	DDX_Text(pDX, IDC_STATIC_EP, m_strEP);
	DDX_Text(pDX, IDC_STATIC_LP, m_strLP);
	DDX_Text(pDX, IDC_EDIT_P, m_dwP);
	DDX_Check(pDX, IDC_CHECK_SWLIMIT, m_bEnSWLimit);
	DDX_Text(pDX, IDC_EDIT_SLMTP, m_lSLMTP);
	DDX_Text(pDX, IDC_EDIT_SLMTM, m_lSLMTM);
}

BEGIN_MESSAGE_MAP(CSoftware_LimitDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BT_MOVE2, &CSoftware_LimitDlg::OnReverseMove)
	ON_BN_CLICKED(IDC_BT_MOVE, &CSoftware_LimitDlg::OnForwardMove)
	ON_BN_CLICKED(IDC_BT_COUNTER_CLEAR, &CSoftware_LimitDlg::OnCounterClear)
	ON_BN_CLICKED(IDC_CHECK_SWLIMIT, &CSoftware_LimitDlg::OnEnableSwlimit)
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CSoftware_LimitDlg message handlers

BOOL CSoftware_LimitDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st I8094/F
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, wTarget_Axis, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, wTarget_Axis, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, wTarget_Axis, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				nTimer = SetTimer( 1, 200, NULL );
				m_btMove.EnableWindow( TRUE );
				m_btMove2.EnableWindow( TRUE );
Initial_Error:
				m_btClear.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}		
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSoftware_LimitDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SOFTWARE_LIMIT_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SOFTWARE_LIMIT_DIALOG));
	}
}
#endif


void CSoftware_LimitDlg::OnReverseMove()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;
	long FixedPulse;

	UpdateData( TRUE );

	if( m_bEnSWLimit == TRUE )
	{
		if( (nErrCode = i8094_set_softlimit( m_CurSlotNo, wTarget_Axis, SW_LIMIT_ENABLE_FEATURE, CMP_SRC_LOGIC_COMMAND, m_lSLMTP, m_lSLMTM )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_set_softlimit() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}
	else
	{
		if( (nErrCode = i8094_set_softlimit( m_CurSlotNo, wTarget_Axis, SW_LIMIT_DISABLE_FEATURE, 0, 0, 0 )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_set_softlimit() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}

	FixedPulse = (long)( 0 - m_dwP );

	if( (nErrCode = i8094_t_move( m_CurSlotNo, wTarget_Axis, 500, 10000, 62500, 1000000, FixedPulse, 0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_t_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
	else
	{
		m_btMove.EnableWindow( FALSE );
		m_btMove2.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );
	}	
}

void CSoftware_LimitDlg::OnForwardMove()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;
	long FixedPulse;

	UpdateData( TRUE );

	if( m_bEnSWLimit == TRUE )
	{
		if( (nErrCode = i8094_set_softlimit( m_CurSlotNo, wTarget_Axis, SW_LIMIT_ENABLE_FEATURE, CMP_SRC_LOGIC_COMMAND, m_lSLMTP, m_lSLMTM )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_set_softlimit() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}
	else
	{
		if( (nErrCode = i8094_set_softlimit( m_CurSlotNo, wTarget_Axis, SW_LIMIT_DISABLE_FEATURE, 0, 0, 0 )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT("i8094_set_softlimit() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}

	FixedPulse = (long)m_dwP;
	if( (nErrCode = i8094_t_move( m_CurSlotNo, wTarget_Axis, 500, 10000, 62500, 1000000, FixedPulse, 0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_t_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
	else
	{
		m_btMove.EnableWindow( FALSE );
		m_btMove2.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );
	}	
}

void CSoftware_LimitDlg::OnCounterClear()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, wTarget_Axis, 0x00 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_set_cmdcounter() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}	

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, wTarget_Axis, 0x00 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_set_enccounter() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}	
}

void CSoftware_LimitDlg::OnEnableSwlimit()
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );
}

void CSoftware_LimitDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter, nEncPosition;
	DWORD dwCurSpeed, dwCurAcceleration;
	BYTE bDone;
	WORD wStopSts;
	short nError;
	CString strTmp;

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		if( (nError = i8094_get_cmdcounter( m_CurSlotNo, wTarget_Axis, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter() failed, error code = %d\n"), nError );
		}
		
		if( (nError = i8094_get_enccounter( m_CurSlotNo, wTarget_Axis, &nEncPosition )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_enccounter() failed, error code = %d\n"), nError );
		}

		if( (nError = i8094_get_speed( m_CurSlotNo, wTarget_Axis, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed() failed, error code = %d\n"), nError );
		}

		if( (nError = i8094_get_acc( m_CurSlotNo, wTarget_Axis, &dwCurAcceleration )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_acc() failed, error code = %d\n"), nError );
		}

		m_strLP.Format( TEXT("%d"), nCmdCounter );

		m_strEP.Format( TEXT("%d"), nEncPosition );

		m_strCV.Format( TEXT("%d"), dwCurSpeed );

		m_strCA.Format( TEXT("%d"), dwCurAcceleration );

		UpdateData( FALSE );

		if( (nError = i8094_motion_done( m_CurSlotNo, wTarget_Axis, &bDone, &wStopSts )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nError );
		}
		else
		{
			if( bDone == 1 )
			{
				m_btMove.EnableWindow( TRUE );
				m_btMove2.EnableWindow( TRUE );
				m_btClear.EnableWindow( TRUE );
			}
		}

		if( (wStopSts & DRIVE_FINISH_WITH_SW_LIMIT_POSITIVE) == DRIVE_FINISH_WITH_SW_LIMIT_POSITIVE ) 
		{
			m_iconSLMTP_ON.ShowWindow( TRUE );
			m_iconSLMTP_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_iconSLMTP_ON.ShowWindow( FALSE );
			m_iconSLMTP_OFF.ShowWindow( TRUE );
		}

		if( (wStopSts & DRIVE_FINISH_WITH_SW_LIMIT_NEGATIVE) == DRIVE_FINISH_WITH_SW_LIMIT_NEGATIVE ) 
		{
			m_iconSLMTM_ON.ShowWindow( TRUE );
			m_iconSLMTM_OFF.ShowWindow( FALSE );
		}
		else
		{
			m_iconSLMTM_ON.ShowWindow( FALSE );
			m_iconSLMTM_OFF.ShowWindow( TRUE );
		}

	}	

	CDialog::OnTimer(nIDEvent);
}

void CSoftware_LimitDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_set_softlimit( m_CurSlotNo, wTarget_Axis, SW_LIMIT_DISABLE_FEATURE, 0, 0, 0 );
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}
}
