// Velocity_PulseCmd_ChangeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Velocity_PulseCmd_Change.h"
#include "Velocity_PulseCmd_ChangeDlg.h"

#include "i8094_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define wTarget_Axis		AXIS_X

// CVelocity_PulseCmd_ChangeDlg dialog

CVelocity_PulseCmd_ChangeDlg::CVelocity_PulseCmd_ChangeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVelocity_PulseCmd_ChangeDlg::IDD, pParent)
	, m_nFixedPulse(5000000)
	, m_dwDriveSpeed(500000)
	, m_dwAcce(1000000)
	, m_dwStartSpeed(50000)
	, m_ModuleNum(0)
	, m_CurSlotNo(INVALID_SLOT_NUMBER)
	, nTimer(-1)
	, m_ErrorOccure(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVelocity_PulseCmd_ChangeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_RESET_CNTER, m_btClear);
	DDX_Control(pDX, IDC_BT_P_CAHNGE, m_btChangeP);
	DDX_Control(pDX, IDC_BT_V_CAHNGE, m_btChangeV);
	DDX_Control(pDX, IDC_BT_START, m_btMove);
	DDX_Control(pDX, IDC_BT_STOP, m_btStop);
	DDX_Text(pDX, IDC_EDIT_P, m_nFixedPulse);
	DDX_Text(pDX, IDC_EDIT_V, m_dwDriveSpeed);
	DDX_Text(pDX, IDC_EDIT_SV, m_dwStartSpeed);
	DDX_Text(pDX, IDC_EDIT_A, m_dwAcce);
}

BEGIN_MESSAGE_MAP(CVelocity_PulseCmd_ChangeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BT_START, &CVelocity_PulseCmd_ChangeDlg::OnStartMove)
	ON_BN_CLICKED(IDC_BT_STOP, &CVelocity_PulseCmd_ChangeDlg::OnStopMove)
	ON_BN_CLICKED(IDC_BT_RESET_CNTER, &CVelocity_PulseCmd_ChangeDlg::OnResetCounter)
	ON_BN_CLICKED(IDC_BT_P_CAHNGE, &CVelocity_PulseCmd_ChangeDlg::OnChangeP)
	ON_BN_CLICKED(IDC_BT_V_CAHNGE, &CVelocity_PulseCmd_ChangeDlg::OnChangeV)
END_MESSAGE_MAP()


// CVelocity_PulseCmd_ChangeDlg message handlers

BOOL CVelocity_PulseCmd_ChangeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here

	CString strErrMsg;	
	short nErrCode;
	
	if( (nErrCode = i8094_scan( &m_ModuleNum )) == SUCCESS_NO_ERROR )
	{
		BYTE bSlotNo;

		// pick up the 1st I8092F
		if( (nErrCode = i8094_get_cardinfo( 0, &bSlotNo )) == SUCCESS_NO_ERROR )
		{

			if( (nErrCode = i8094_open( bSlotNo )) == SUCCESS_NO_ERROR )
			{
				m_CurSlotNo = bSlotNo;

				if( (nErrCode = i8094_set_pls_cfg( m_CurSlotNo, wTarget_Axis, PULSE_MODE_CW_CCW, PULSE_LOGIC_ACTIVE_HIGH, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_pls_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_enc_cfg( m_CurSlotNo, wTarget_Axis, ENCODER_MODE_CW_CCW, 0x00 )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_enc_cfg() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}

				if( (nErrCode = i8094_set_limit( m_CurSlotNo, wTarget_Axis, LIMIT_LOGIC_ACTIVE_LOW )) != SUCCESS_NO_ERROR )
				{
					strErrMsg.Format( TEXT("i8094_set_limit() falied with error code : %d"), nErrCode );
					AfxMessageBox( strErrMsg );
					goto Initial_Error;
				}


				nTimer = SetTimer( 1, 200, NULL );
				m_btMove.EnableWindow( TRUE );
Initial_Error:
				m_btClear.EnableWindow( TRUE );

			}
			else
			{
				strErrMsg.Format( TEXT("i8094_open() falied with error code : %d"), nErrCode );
				AfxMessageBox( strErrMsg );
			}
		}
		else
		{
			strErrMsg.Format( TEXT("i8094_get_cardinfo() falied with error code : %d"), nErrCode );
			AfxMessageBox( strErrMsg );
		}

	}
	else
	{
		strErrMsg.Format( TEXT("i8094_scan() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}		

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CVelocity_PulseCmd_ChangeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_VELOCITY_PULSECMD_CHANGE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_VELOCITY_PULSECMD_CHANGE_DIALOG));
	}
}
#endif


void CVelocity_PulseCmd_ChangeDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( nTimer != -1 )
		KillTimer( nTimer );

	if( m_CurSlotNo != INVALID_SLOT_NUMBER )
	{
		i8094_close( m_CurSlotNo ); 
		m_CurSlotNo = INVALID_SLOT_NUMBER;
	}
}

void CVelocity_PulseCmd_ChangeDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	long nCmdCounter;
	DWORD dwCurSpeed, dwCurAcceleration;
	BYTE bDone;
	WORD wStopStatus;
	short nErrCode;
	CString strTmp;

	if( (m_CurSlotNo != INVALID_SLOT_NUMBER) && (m_ErrorOccure == 0x00) )
	{
		if( (nErrCode = i8094_get_cmdcounter( m_CurSlotNo, wTarget_Axis, &nCmdCounter )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_cmdcounter() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_speed( m_CurSlotNo, wTarget_Axis, &dwCurSpeed )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_speed() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_get_acc( m_CurSlotNo, wTarget_Axis, &dwCurAcceleration )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_get_acc() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}

		if( (nErrCode = i8094_motion_done( m_CurSlotNo, wTarget_Axis, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
		{
			TRACE( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
			m_ErrorOccure = 0x01;
		}
		else
		{
			if( bDone == MOTION_DONE )
			{
				m_btChangeV.EnableWindow( FALSE );
				m_btChangeP.EnableWindow( FALSE );
				m_btStop.EnableWindow( FALSE );
				m_btMove.EnableWindow( TRUE );
				m_btClear.EnableWindow( TRUE );
			}	
		}

		strTmp.Format( TEXT("%d"), nCmdCounter );
		SetDlgItemText( IDC_STATIC_LP, strTmp );

		strTmp.Format( TEXT("%d"), dwCurSpeed );
		SetDlgItemText( IDC_STATIC_CV, strTmp );

		strTmp.Format( TEXT("%d"), dwCurAcceleration );
		SetDlgItemText( IDC_STATIC_CA, strTmp );
	}
	CDialog::OnTimer(nIDEvent);
}

void CVelocity_PulseCmd_ChangeDlg::OnStartMove()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	UpdateData(TRUE);

	nErrCode = i8094_t_move( m_CurSlotNo, wTarget_Axis, m_dwStartSpeed, m_dwDriveSpeed, m_dwAcce, m_dwAcce, m_nFixedPulse, 0x00 );

	if( nErrCode != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_t_move() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
	else
	{
		m_btStop.EnableWindow( TRUE );
		m_btChangeV.EnableWindow( TRUE );
		m_btChangeP.EnableWindow( TRUE );
		m_btMove.EnableWindow( FALSE );
		m_btClear.EnableWindow( FALSE );

		m_ErrorOccure = 0x00;
	}		
}

void CVelocity_PulseCmd_ChangeDlg::OnStopMove()
{
	// TODO: Add your control notification handler code here
	BYTE bDone;
	WORD wStopStatus;
	short nErrCode;
	CString strErrMsg;

	if( (nErrCode = i8094_motion_done( m_CurSlotNo, wTarget_Axis, &bDone, &wStopStatus )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_motion_done() failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}

	if( bDone != MOTION_DONE )
	{
		if( (nErrCode = i8094_stop_move( m_CurSlotNo, wTarget_Axis, STOP_SLOWDOWN )) != SUCCESS_NO_ERROR )
		{
			strErrMsg.Format( TEXT(" i8094_stop_move() failed, error code = %d\n"), nErrCode );
			AfxMessageBox( strErrMsg );
			return;
		}
	}
	else
	{
		TRACE( TEXT(" Motion Done! Finish Status [0x%04X]\n"), wStopStatus );
		m_btChangeV.EnableWindow( FALSE );
		m_btChangeP.EnableWindow( FALSE );
		m_btStop.EnableWindow( FALSE );
		m_btMove.EnableWindow( TRUE );
		m_btClear.EnableWindow( TRUE );
	}	
}

void CVelocity_PulseCmd_ChangeDlg::OnResetCounter()
{
	// TODO: Add your control notification handler code here
	short nErrCode;
	CString strErrMsg;

	if( (nErrCode = i8094_set_enccounter( m_CurSlotNo, wTarget_Axis, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_enccounter() failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}
	
	if( (nErrCode = i8094_set_cmdcounter( m_CurSlotNo, wTarget_Axis, (long)0 )) != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT(" i8094_set_cmdcounter() failed, error code = %d\n"), nErrCode );
		AfxMessageBox( strErrMsg );
		return;
	}	
}

void CVelocity_PulseCmd_ChangeDlg::OnChangeP()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	UpdateData(TRUE);

	nErrCode = i8094_change_p( m_CurSlotNo, wTarget_Axis, m_nFixedPulse );

	if( nErrCode != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_t_change_p() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}	
}

void CVelocity_PulseCmd_ChangeDlg::OnChangeV()
{
	// TODO: Add your control notification handler code here
	CString strErrMsg;	
	short nErrCode;

	UpdateData(TRUE);

	nErrCode = i8094_t_change_v( m_CurSlotNo, wTarget_Axis, m_dwDriveSpeed );

	if( nErrCode != SUCCESS_NO_ERROR )
	{
		strErrMsg.Format( TEXT("i8094_t_change_v() falied with error code : %d"), nErrCode );
		AfxMessageBox( strErrMsg );
	}
}
